export declare const ArborSerializeAs: unique symbol;
export type Typed = {
    $type: string;
    $value: object;
};
export type SerializedBy<T extends Serializable> = ReturnType<T["toJSON"]>;
export type Serialized<T> = {
    [K in keyof T as T[K] extends Function ? never : K]: T[K];
};
export type Serializable = {
    toJSON(): object;
};
export type Type = {
    new (...args: any[]): unknown;
};
export type CustomDeserialization<T = object> = {
    fromJSON(obj: object): T;
};
export declare class Json {
    #private;
    serialize: <T extends Type>(target: T, _context?: unknown) => void;
    serializeAs<T extends Type>(key: string): (target: T, _context?: unknown) => void;
    stringify(value: object): string;
    parse<T>(value: string): T;
    protected register(...types: Type[]): void;
    private reviver;
}
//# sourceMappingURL=index.d.ts.map